//
//  MovieTitle.m
//  Example
//
//  Created by Bertils mini on 2013-10-29.
//  Copyright (c) 2013 Sork Software. All rights reserved.
//

#import "MovieTitle.h"

@implementation MovieTitle

#pragma mark - Initializers

+ (MovieTitle *)movieTitle {
  
  return [self new];
}

+ (MovieTitle *)movieTitle:(NSString *)title withGenre:(NSUInteger)genre {
  
  return [[self alloc] initWithTitle:title genre:genre];
}

- (instancetype)init {
  
  return [self initWithTitle:@"" genre:0];
}

// The designated initializer
- (instancetype)initWithTitle:(NSString *)title genre:(NSUInteger)genre {
  if ((self = [super init])) {
    _movieTitle = title;
    _movieGenre = genre;
	}
  return self;
}

#pragma mark - Debugging

- (NSString *)description {
  
  return [NSString stringWithFormat:@"Movie with title %@ and genre: %lu", self.movieTitle, (unsigned long)self.movieGenre];
}

@end
