//
//  SSDetailViewController.m
//  Example
//
//  Created by Bertils mini on 2013-10-17.
//  Copyright (c) 2013-14 Sork Software. All rights reserved.
//

#import "SSDetailViewController.h"
#import "SSMasterViewController.h"
#import "MovieTitle.h"

@interface SSDetailViewController ()
- (void)configureView;
@end

@implementation SSDetailViewController

#pragma mark - Lifecycle

- (void)viewDidLoad {
  [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib
  [self configureView];
}

#pragma mark - Managing the detail item

- (void)setDetailItem:(id)newDetailItem {
  _detailItem = newDetailItem;
  
  // Update the view
  [self configureView];
  
  if (self.masterPopoverController != nil) {
    [self.masterPopoverController dismissPopoverAnimated:YES];
  }
}

// Update the user interface for the detail item
- (void)configureView {
  SSMasterViewController *masterViewController = (SSMasterViewController *)[[self.splitViewController.viewControllers firstObject] topViewController];
  
  if (self.detailItem) {
    MovieTitle *detailTitle = (MovieTitle *)self.detailItem;
    self.detailDescriptionLabel.text = [NSString stringWithFormat:@"The movie %@ is a %@", detailTitle.movieTitle,
      masterViewController.genres[detailTitle.movieGenre]];
  }
}

#pragma mark - Split view stuff

- (void)splitViewController:(UISplitViewController *)splitController willHideViewController:(UIViewController *)viewController withBarButtonItem:(UIBarButtonItem *)barButtonItem forPopoverController:(UIPopoverController *)popoverController {
  barButtonItem.title = NSLocalizedString(@"Master", @"Master");
  [self.navigationItem setLeftBarButtonItem:barButtonItem animated:YES];
  self.masterPopoverController = popoverController;
}

- (void)splitViewController:(UISplitViewController *)splitController willShowViewController:(UIViewController *)viewController invalidatingBarButtonItem:(UIBarButtonItem *)barButtonItem {
  // Called when the view is shown again in the split view, invalidating the button and popover controller.
  [self.navigationItem setLeftBarButtonItem:nil animated:YES];
  self.masterPopoverController = nil;
}

@end
